﻿;======================================================================
; Module/File:     Button_AddImage.pb
; Function:        Button: Add loaded or stock-imaged to pb-Button with alignment - Linux
; Author:          Oma (Charly Bauer)
; Date:            June 26, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22
; Target OS:       Linux - Ubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

EnableExplicit

ImportC ""
	gtk_button_set_image(*button.GtkButton, *image.GtkWidget)
	gtk_button_set_image_position(*button.GtkButton, position)
	gtk_image_clear(*image.GtkWidget)
	gtk_button_set_alignment(*button.GtkButton, xalign.f, yalign.f)
EndImport

#MainWin= 0

Enumeration
	#myButton1
	#myButton2
	#myButton3
	#myButton4
	#myButton5
EndEnumeration

Global.i gEvent, gQuit
Global *image1, *image2, *image3, *image4

Procedure AddImageToButton(Gadget, *Pic, Label.s, Alignment)
	gtk_button_set_image(GadgetID(Gadget), *Pic)
	gtk_button_set_label_(GadgetID(Gadget), @Label)
	gtk_button_set_image_position(GadgetID(Gadget), Alignment)
EndProcedure

If OpenWindow(#MainWin, #PB_Ignore, #PB_Ignore, 250, 250, "Linux-Test Button with image")
	
	;for loading icons choose your own image-adresses ...
; 	*image1= gtk_image_new_from_file_(@"/home/charly-xubuntu/Programming/PureBasic/purebasic/Source/Icons/Own/Back.png")
; 	*image2= gtk_image_new_from_file_(@"/home/charly-xubuntu/Programming/PureBasic/purebasic/Source/Icons/Own/Find.png")
; 	*image3= gtk_image_new_from_file_(@"/home/charly-xubuntu/Programming/PureBasic/purebasic/Source/Icons/Own/Previous.png")
; 	*image4= gtk_image_new_from_file_(@"/home/charly-xubuntu/Programming/PureBasic/purebasic/Source/Icons/Own/Stop sign.png")
	;or use stock-images ...
	*image1= gtk_image_new_from_stock_(@"gtk-go-back", #GTK_ICON_SIZE_MENU);  #GTK_ICON_SIZE_BUTTON
	*image2= gtk_image_new_from_stock_(@"gtk-find", #GTK_ICON_SIZE_MENU)
	*image3= gtk_image_new_from_stock_(@"gtk-goto-first", #GTK_ICON_SIZE_MENU)
	*image4= gtk_image_new_from_stock_(@"gtk-stop", #GTK_ICON_SIZE_MENU)
	
	ButtonGadget(#myButton1, 5, 5, 200, 30, "   Button with image", #PB_Button_Toggle)
	 AddImageToButton(#myButton1, *image1, "1. Button with image", #GTK_POS_LEFT)
	ButtonGadget(#myButton2, 5, 40, 200, 30, "   Button with image")
	 AddImageToButton(#myButton2, *image2, "2. Button with image", #GTK_POS_RIGHT)
	ButtonGadget(#myButton3, 5, 75, 200, 50, "   Button with image")
	 AddImageToButton(#myButton3, *image3, "3. Button with image", #GTK_POS_TOP)
	ButtonGadget(#myButton4, 5, 130, 200, 50, "   Button with image")
	 AddImageToButton(#myButton4, *image4, "4. Button with image", #GTK_POS_BOTTOM)
	ButtonGadget(#myButton5, 5, 185, 200, 50, "Button with alignment", #PB_Button_Right)
	
	gtk_button_set_alignment(GadgetID(#myButton5), 1.0, 1.0);    geht nur über ImportC
	
Else
	End
EndIf

Repeat
	gEvent = WaitWindowEvent()
	If EventWindow()= #MainWin
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
		EndSelect
	EndIf
Until gQuit

;free image-memory...
gtk_image_clear(*image1)
gtk_image_clear(*image2)
gtk_image_clear(*image3)
gtk_image_clear(*image4)

End
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 10
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/