﻿;======================================================================
; Module/File:     TV_Expand&CollapseAll.pb - Linux
; Function:        TreeGadget: Alle TreeView (TreeGadget, ExplorerTree, ...): Alle Knoten expandieren / kollabieren - Linux
; Author:          Oma (Charly Bauer)
; Date:            Juli 22, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

EnableExplicit

; Object constants
#MainWin= 0
#TG1= 0
#TG2= 1
#BG1= 2

#WinX= 200
#WinY= 200
#WinW= 500
#WinH= 330

Global.l gEvent, gQuit

Declare ExpandAll(Gadget)

Procedure CreateWindow_Main()
	Protected.l I, O

	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Explorer&Tree - expand all nodes", #PB_Window_SystemMenu)
		TreeGadget(0, 10, 30, 230, 280);                                             TreeGadget Standard
		TreeGadget(1, 250, 30, 230, 280, #PB_Tree_CheckBoxes | #PB_Tree_NoLines);    TreeGadget mit Checkboxen + ohne Linien
		ButtonGadget(#BG1, 5, 5, 100, 25, "expand/collapse all", #PB_Button_Toggle)
		
		For I = 0 To 1
			For O = 0 To 10
				AddGadgetItem (I, -1, "Normal Item "+Str(O), 0, 0)
				AddGadgetItem (I, -1, "Node "+Str(O), 0, 0)
				AddGadgetItem(I, -1, "Sub-Item 1", 0, 1)
				AddGadgetItem(I, -1, "Sub-Item 2", 0, 1)
				AddGadgetItem(I, -1, "Sub-Item 3", 0, 1)
				AddGadgetItem(I, -1, "Sub-Item 4", 0, 1)
				AddGadgetItem (I, -1, "File "+Str(O), 0, 0)
			Next O
		Next I
		
	EndIf
EndProcedure

Procedure ExpandAll(Gadget)
	Protected.i I
	; only way in ExplorerTreeGadget (in TreeGadget also possible) ...
	If GetGadgetState(#BG1)
		gtk_tree_view_expand_all_(GadgetID(Gadget))
	Else
		gtk_tree_view_collapse_all_(GadgetID(Gadget))
	EndIf
	
	; instead off (only TreeGadget) ...
	; 	For I= 0 To CountGadgetItems(Gadget)- 1
	; 		Debug "drin"
	; 		If GetGadgetState(#BG1)
	; 			SetGadgetItemState(Gadget, I, #PB_Tree_Expanded)
	; 		Else
	; 			SetGadgetItemState(Gadget, I, #PB_Tree_Collapsed)
	; 		EndIf
	; 	Next I
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()
	
	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
		Case #PB_Event_Gadget
			Select EventGadget()
				Case #BG1
					ExpandAll(0)
					ExpandAll(1)
			EndSelect
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.22 LTS (Linux - x86)
; CursorPosition = 35
; FirstLine = 30
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/