﻿;======================================================================
; Module/File:     LIG_GetSetColumnVisible.pb - Linux
; Function:        LIG: Zeilenhöhe einstellen - Abfrage fuchst noch - Linux
; Author:          Oma (Charly Bauer) - example from ?
; Date:            Juli 10, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

;ACHTUNG: FUNKTIONIERT NUR MIT GEWISSEN LIG_FLAGS !!!

EnableExplicit

; ImportC ""
; 	gtk_cell_renderer_get_preferred_height(*CellRenderer.GtkCellRenderer, *widget.GtkWidget, *MinSize, *NatSize);   without function
; EndImport

; Object constants
#MainWin= 0
#LIG= 0
#But= 1

#WinX= 200
#WinY= 200
#WinW= 500
#WinH= 450

Global.l gEvent, gQuit, Counter= 10


;- Functions ...

Procedure.i GetCellRenderer(Gadget, CellRendererID.I)
	Static    *CellRenderer0.GtkCellRenderer
	Static    *CellRenderer1.GtkCellRenderer
	Protected *CellRendererList
	Protected *Column
	
	If *CellRenderer0 = 0
		; ----- Get column 0
		*Column = gtk_tree_view_get_column_(GadgetID(Gadget), 0)
		
		If *Column
			; ----- Get list of cell renderers for column 0
			*CellRendererList = gtk_tree_view_column_get_cell_renderers_(*Column)
			
			If *CellRendererList
				; ----- Get 1st cell renderer from list for changing row height
				*CellRenderer0 = g_list_nth_data_(*CellRendererList, 0)
				; ----- Get 2nd cell renderer from list to obtain current row height
				*CellRenderer1 = g_list_nth_data_(*CellRendererList, 1);            gibt noch 0 zurück
			EndIf
		EndIf
	EndIf
	
	If CellRendererID = 0
		ProcedureReturn *CellRenderer0
	Else
		ProcedureReturn *CellRenderer1
	EndIf
EndProcedure


Procedure.l LIG_GetItemHeight(Gadget);              liefert mit checkboxes immer '0', ohne immer 19 zurück
	Protected *CellRenderer.GtkCellRenderer
	Protected.l x, y, w, h
	Protected.l MinSize, NatSize
	
	*CellRenderer = GetCellRenderer(Gadget, 1)
	If *CellRenderer
		gtk_cell_renderer_get_size_(*CellRenderer, GadgetID(Gadget), 0, @x, @y, @w, @h)
		;gtk_cell_renderer_get_preferred_height(*CellRenderer, 0, @MinSize, @NatSize)
	EndIf
	
	ProcedureReturn h
EndProcedure

Procedure LIG_SetItemHeight(Gadget, ItemH)
	Protected *CellRenderer.GtkCellRenderer
	Protected *Column
	
	*Column = gtk_tree_view_get_column_(GadgetID(Gadget), 0)
	
	If *Column
		*CellRenderer = GetCellRenderer(Gadget, 0)
		*CellRenderer\height = ItemH
		gtk_tree_view_column_clear_attributes_(*Column, *CellRenderer)
	EndIf
EndProcedure

Procedure IncreaseRowHeight()
	If Counter< 30
		LIG_SetItemHeight(#LIG, Counter)
		Debug LIG_GetItemHeight(#LIG);                         Gibt noch '0' zurück
		Counter+ 1
	EndIf
EndProcedure

;- 
;- Example ...
Procedure CreateWindow_Main()
	Protected.l I, O
	Protected *Column
	#Img1= 0
	#Img2= 1
	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Set line-height - wait", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
		ListIconGadget(#LIG, 5, 5, 480, 380, "Spalte 1", 70, #PB_ListIcon_AlwaysShowSelection | #PB_ListIcon_GridLines | #PB_ListIcon_CheckBoxes)
		ButtonGadget(#But, 5, 400, 150, 25, "Zeilenhöhe abfragen", #PB_Button_Toggle)
		For O= 1 To 4
			AddGadgetColumn(#LIG, O, "Spalte "+Str(O+ 1), 70)
		Next O
		For I= 1 To 20
			AddGadgetItem(#LIG, -1, Str(I)+".1")
		Next I
		
		For O= 1 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(I+1)+"."+Str(O+1), O)
			Next I
		Next O
		
		For O= 3 To 4
			For I= 0 To 19
				SetGadgetItemText(#LIG, I, Str(20-I)+"."+Str(O+1), O)
			Next I
		Next O

	EndIf

EndProcedure

CreateWindow_Main()

Debug LIG_GetItemHeight(#LIG)

AddWindowTimer(#MainWin, 0, 500)

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
		Case #PB_Event_Gadget
			If EventGadget()= #But
				Debug LIG_GetItemHeight(#LIG)
			EndIf
		Case #PB_Event_Timer
			IncreaseRowHeight()
	EndSelect
	
Until gQuit

RemoveWindowTimer(#MainWin, 0)
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 106
; FirstLine = 87
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/