﻿;======================================================================
; Module/File:     LIG_Scroll2Item.pb - Linux
; Function:        LIG: scrollt zu angegebener Zeile (item) - Linux
; Author:          Oma (Charly Bauer)
; Date:            Juli 07, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

Global.i I


;- Hilfsroutine ...
Procedure.i TV_GetPathFromIndex(Gadget, Row);             Pfad-Zeiger anhand des Index / Zeile
	Protected iter.GtkTreeIter
	Protected *tModel
	Protected *tPath
	
	*tModel= gtk_tree_view_get_model_(GadgetID(Gadget))
	gtk_tree_model_get_iter_from_string_(*tModel, @iter, Str(Row))
	*tPath = gtk_tree_model_get_path_(*tModel , @iter)
	
	ProcedureReturn *tPath
EndProcedure
;- End Hilfsroutine

;-Function ...
Procedure TV_Scroll2Item(Gadget, Item);                              alignment funktioniert noch nicht
	Protected *tPath= TV_GetPathFromIndex(Gadget, Item)
	gtk_tree_view_scroll_to_cell_(GadgetID(Gadget), *tPath, #Null, #False, 0.0, 0.0)
	gtk_tree_path_free_ (*tPath)
EndProcedure


;-Example ...
If OpenWindow(0, 100, 100, 150, 200, "Scroll to Item", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	ListIconGadget(0, 5, 5, WindowWidth(0) - 10, WindowHeight(0) - 40, "Spalte 1", 60)
	SpinGadget(1, 5, WindowHeight(0)- 30, 70, 25, 1, 100, #PB_Spin_Numeric)
	SetGadgetText(1, "1")
	ButtonGadget(2, 75, WindowHeight(0) - 30, 70, 25, "Anzeigen")
	For I= 1 To 100
		AddGadgetItem(0, -1, "Zeile " + Str(i))
	Next I
	
	Repeat
		Event = WaitWindowEvent()
		
		If Event = #PB_Event_Gadget
			Select EventGadget()
				Case 1
					SetGadgetState(1, Val(GetGadgetText(1)))
				Case 2
					CompilerSelect #PB_Compiler_OS
						CompilerCase #PB_OS_Linux
							TV_Scroll2Item(Gadget, GetGadgetState(1)-1)
						CompilerCase #PB_OS_Windows
							SendMessage_(GadgetID(0), #LVM_ENSUREVISIBLE, GetGadgetState(1), #True)
					CompilerEndSelect
			EndSelect
		EndIf
	Until Event= #PB_Event_CloseWindow
EndIf
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 12
; Folding = -
; EnableXP
; UseMainFile = LIG_Scroll2Item.pb
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/