﻿;======================================================================
; Module/File:     LV_GetVisibleItemRange.pb - Linux
; Function:        LVG: LV-erstes und letztes (teilweise) sichtbares Item holen - Linux
; Author:          Oma (Charly Bauer)
; Date:            Juli 08, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================


EnableExplicit

ImportC ""
	 gtk_tree_view_get_visible_range(*tree_view.GtkTreeView, *tPathF, *tPathL)
EndImport

; Object constants
#MainWin= 0
#LV= 0
#CbBox= 1

#WinX= 200
#WinY= 200
#WinW= 300
#WinH= 420

Global.l gEvent, gQuit
Global gFItem, gLItem


;- Functions ...
Procedure.i TV_GetIndexFromPath(Gadget, *tPath);          LIG: Index / Zeile (= Item) anhand des Pfad-Zeigers holen
	ProcedureReturn PeekL(gtk_tree_path_get_indices_(*tPath))
EndProcedure

Procedure TV_GetItemRange(Gadget, *FItem, *LItem)
	Protected.i Ret
	Protected *tPathF, *tPathL
	
	Ret= gtk_tree_view_get_visible_range(GadgetID(Gadget), @*tPathF, @*tPathL)
	If Ret
		PokeL(*FItem, TV_GetIndexFromPath(Gadget, *tPathF))
		PokeL(*LItem, TV_GetIndexFromPath(Gadget, *tPathL))
;  		Debug "first line : " + Str(PeekL(*FItem));            Zugriff in Proc
;  		Debug "last line  : " + Str(PeekL(*LItem))
	Else
		Debug "not Okay"
	EndIf
	gtk_tree_path_free_(*tPathF)
	gtk_tree_path_free_(*tPathL)
	
	ProcedureReturn Ret
EndProcedure

;- Example ...
Procedure CreateWindow_Main()
	Protected.l I, O
	Protected *Column
	#Img1= 0
	#Img2= 1
	If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "Get first & last visible item", #PB_Window_SystemMenu | #PB_Window_WindowCentered)
		ListViewGadget(#LV, 5, 5, 290, 380)
		ButtonGadget(#CbBox, 5, 390, 100, 25, "Debug Range")
		For I= 1 To 40
			AddGadgetItem(#LV, -1, Str(I)+".1")
		Next I
	EndIf
	
EndProcedure

CreateWindow_Main()

Repeat
	gEvent= WaitWindowEvent()

	Select gEvent
		Case #PB_Event_CloseWindow
			gQuit= #True
		Case #PB_Event_Gadget
			Select EventGadget()
				Case #CbBox
					If TV_GetItemRange(#LV, @gFItem, @gLItem)
							Debug "first line : " + Str(gFItem)
							Debug "last line  : " + Str(gLItem)
					EndIf
			EndSelect
	EndSelect
	
Until gQuit
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 62
; FirstLine = 39
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/