﻿;======================================================================
; Module/File:     Panel_PopupOnTab.pb - Linux
; Function:        PanelGadget: tab-popup on rightclick - Linux
; Author:          Oma (Charly Bauer)
; Date:            Aug. 23, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

EnableExplicit

; Object constants
#MainWin= 0
#Text1  = 0
#Panel1 = 1

#WinX=300
#WinY=200
#WinW=410
#WinH=310

Global.i gEvent, gQuit
Global.i I, gRiders= 4
Global.s gS
Global   *gMem, *widget.GtkWidget

Procedure AsciiToUTF8(SAscii.s)
	*gMem= AllocateMemory(StringByteLength(SAscii, #PB_UTF8) + 1)
	PokeS(*gMem, SAscii, -1,  #PB_UTF8)
	ProcedureReturn *gMem
EndProcedure

If OpenWindow(#MainWin, 100, 120, #WinW, #WinH, "PanelGadget: tab-popup on rightclick", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#Text1, 5, 5, 300, 20, "Rightclick on tab opens popup...")
	PanelGadget(#Panel1, 0, 30, 400, 270)
	
	For I= 0 To gRiders- 1
		AddGadgetItem(#Panel1, -1, " Tab (Rider) "+Str(I))
		TextGadget(#PB_Any, 5, 5, 200, 20, "Panel "+Str(I))
		
		;   You can give the popupitems own labels instead of 'Seite n' (german) ...
		*widget= gtk_notebook_get_nth_page_(GadgetID(#Panel1), I)
		gS= "TabPopupItem " + Str(I)
		gtk_notebook_set_menu_label_text_(GadgetID(#Panel1), *widget, AsciiToUTF8(gS));  with 'Umlauts' use 'AsciiToUTF8_*.pb' in Misc
		FreeMemory(*gMem);                                                               Free mem for AsciiToUTF8() !
		
	Next I
	CloseGadgetList()
	
	gtk_notebook_popup_enable_(GadgetID(#Panel1));                          to enable the popup on tabs
	;gtk_notebook_popup_disable_(GadgetID(#Panel1));                         to disable the popup (default)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
		EndSelect
		
	Until gQuit
	
EndIf

End  
; IDE Options = PureBasic 5.30 (Linux - x86)
; CursorPosition = 10
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/