﻿;======================================================================
; Module/File:     Trackbar_SetStepSize.pb - Linux
; Function:        Trackbar: setzt Schrittweiten die mit PureBasic nicht gesetzt werden können - Linux
; Author:          Oma (Charly Bauer)
; Date:            Aug. 13, 2014
; Version:         0.1
; Target Compiler: PureBasic 5.22 LTS - Linux x86
; Target OS:       Linux - Xubuntu
; License:         Free, unrestricted, no warranty
;======================================================================

ImportC ""
	gtk_window_set_opacity(*window.GtkWindow, opacity.d)
	gtk_scale_clear_marks(*scale.GtkScale)
	gtk_scale_add_mark(*scale.GtkScale, value.d, position.i, *markup)
	gtk_range_get_value.d(*range.GtkRange)
EndImport

EnableExplicit

; Object constants
#MainWin= 0
#TBar1    = 0
#SPBret   = 1
#SGtkRet  = 2

#WinX=300
#WinY=200
#WinW=250
#WinH=200

Global.i I, gEvent, gQuit, gCounter
Global *gWidget.GtkWidget, *gRange.GtkRange

ProcedureC GetScaleValue(*widget, user_data)
	SetGadgetText(#SGtkRet, StrD(gtk_range_get_value(*widget)))
EndProcedure

If OpenWindow(#MainWin, #WinX, #WinY, #WinW, #WinH, "trackbar w. 'double'-stepsize", #PB_Window_SystemMenu | #PB_Window_ScreenCentered)
	TextGadget(#PB_Any, 5, 10, 200, 20, "20-steps with left/right-arrow")
	TextGadget(#PB_Any, 5, 80, 100, 20, "PB-returnvalue  :")
	StringGadget(#SPBret, 100, 75, 50, 25, "", #PB_String_ReadOnly)
	TextGadget(#PB_Any, 5, 110, 100, 20, "Gtk-returnvalue:")
	StringGadget(#SGtkRet, 100, 105, 50, 25, "", #PB_String_ReadOnly)
	
	TrackBarGadget(#TBar1, 5, 30, 235, 40, 0, 10);                     no 'step'-size or count possible
	
		; ----- additional trackbar settings ...
	*gWidget= GadgetID(#TBar1)
	gtk_scale_set_digits_(*gWidget, 1);                                set digit-count
	gtk_scale_set_value_pos_(*gWidget, #GTK_POS_RIGHT);                additional display value at right side
	gtk_scale_set_draw_value_(*gWidget, #True);                        display ON
	gtk_scale_clear_marks(*gWidget);                                   no marks => wrong cause pb-int-parameter
	*gRange = *gWidget;                                                get range-class
	*gRange\adjustment\value= 5.0;                                     preset value
	*gRange\adjustment\step_increment= 0.5;                            step 0.5 = 20  steps
	For I= 0 To 20;                                                    and 21 marks
		gtk_scale_add_mark(*gWidget, I/2, #GTK_POS_TOP, #Null)
	Next I
	
	g_signal_connect_data_(*gWidget, "value-changed", @GetScaleValue(), *gWidget, #Null, #Null)
	
	Repeat
		gEvent= WaitWindowEvent()
		
		Select gEvent
			Case #PB_Event_CloseWindow
				gQuit= #True
			Case #PB_Event_Gadget
				If EventGadget()= #TBar1
					SetGadgetText(#SPBret, StrD(GetGadgetState(#TBar1)));      no 'double'-type return possible
				EndIf
		EndSelect
		
	Until gQuit
EndIf
; IDE Options = PureBasic 5.22 LTS (Linux - x86)
; CursorPosition = 8
; Folding = -
; EnableXP
; CurrentDirectory = /home/charly-xubuntu/Programming/PureBasic/purebasic/